
var GameScene = cc.Scene.extend({

	gameConfig:null,
	updateView:null,
	updateMgr:null,
	startBg:null, 
	isOtherGame:false,

	ctor:function(jsc, config, updateView)
	{
		cc.Scene.prototype.ctor.call(this);
		this.jsc = jsc;
		this.jsc.JS_GET_VALUE = 1002;
		this.gameConfig = config;
		this.gameConfig.bigVersion = jsc.versionCode;
		this.updateView = updateView;
		this.updateView.setTips("正在检测游戏...");
		this.addChild(this.updateView, 100);
		// print("#md5", "123", md5("123"));


		//镜头层次设置
		// cc.director.setProjection(cc.Director.PROJECTION_2D);
		// var camera1 = cc.Camera.createOrthographic(cc.winSize.width,cc.winSize.height,-1000,1000);
		// camera1.setDepth(-5);
		// camera1.setCameraFlag(cc.CameraFlag.USER1);
		// this.addChild(camera1);
		// var camera2 = cc.Camera.createOrthographic(cc.winSize.width,cc.winSize.height,-1000,1000);
		// camera2.setDepth(-4);
		// camera2.setCameraFlag(cc.CameraFlag.USER2);
		// this.addChild(camera2);
		// var camera3 = cc.Camera.createOrthographic(cc.winSize.width,cc.winSize.height,-1000,1000);
		// camera3.setDepth(-3);
		// camera3.setCameraFlag(cc.CameraFlag.USER3);
		// this.addChild(camera3);
		// var camera4 = cc.Camera.createOrthographic(cc.winSize.width,cc.winSize.height,-1000,1000);
		// camera4.setDepth(-2);
		// camera4.setCameraFlag(cc.CameraFlag.USER4);
		// this.addChild(camera4);
	},
	stat : function(type) {
		// 启动游戏   		1 
		// 通过版本检测   	2
		// 更新资源   		3
		// 已登录数		4
		// 已创角数		5
		// 进入游戏数		6
		var isPostable = !this.gameConfig.isNoSdkOrTestSdk();
		var url = this.gameConfig.statUrl;
		// url = "http://s1.syyj.geiniwan.com/game/api/set_create_type.php?type={0}&ky_code={1}" + 
		// 		"&gcid={2}&sh_ver={3}&ky_id={4}";
		if(isPostable && !!url && url.length > 0) {
			var ky_code = this.jsc.jsCall([ this.jsc.JS_GET_VALUE, "ky_code" ]),
				gcid = this.jsc.jsCall([ this.jsc.JS_GET_VALUE, "gcid" ]),
				sh_ver = this.jsc.jsCall([ this.jsc.JS_GET_VALUE, "sh_ver" ]),
				ky_id = this.jsc.jsCall([ this.jsc.JS_GET_VALUE, "ky_id" ]);
			url = url.format(type, ky_code, gcid, sh_ver, ky_id);
			print("#stat url:", url);
			cc.loader.loadTxtRemote(url, function(errInfo, txt) {
				print("#stat return", errInfo, txt);
			});
		}
	},
	startGame : function() { 

		print("#resVersion", this.gameConfig.resVersion);
		//存储渠道ID
		var LOCALAGENTID = "LOCALAGENTID",
			LOCAL_ISDOWNLOAD = "local_isdownload",
			localAgentId = this.jsc.readKV(LOCALAGENTID),
			localIsDownload = this.jsc.readKV(LOCAL_ISDOWNLOAD);
		if(!localAgentId || localAgentId.length == 0) {
			print("#写入cache", LOCALAGENTID, this.gameConfig.agentId);
			this.jsc.writeKV(LOCALAGENTID, this.gameConfig.agentId);
		}
		else {
			print("#代理ID设置为", localAgentId);
			this.gameConfig.setAgentId(parseInt(localAgentId));
		}
		if(!localIsDownload || localIsDownload.length == 0) {
			print("#写入cache", LOCAL_ISDOWNLOAD, this.gameConfig.isDownload);
			this.jsc.writeKV(LOCAL_ISDOWNLOAD, this.gameConfig.isDownload);
		}
		else {
			print("#isDownload设置为", localIsDownload);
			this.gameConfig.isDownload = (localIsDownload == "true");
		}
		if(this.gameConfig.isRuntime)
		{
			//runtime直接进入游戏
		}
		else
		{
			//非runtime执行更新
			var sdkId = 0,
				this_ = this;
			if( this.gameConfig.isAndroid() || this.gameConfig.isIOS() ) {
				sdkId = parseInt(this.jsc.getSdkId() || "0");
			}
			
			this.gameConfig.setSdkId(sdkId);
			this.stat(1);

			this.updateMgr = new GameUpdate(this); 
			// this.sdkApi = new SdkAPI(this,en,className);
			this.updateMgr.firstOpen(function() {
				this_.updateMgr.resetConfig();
				if(this_.gameConfig.isNoSdkOrTestSdk()) {
						this_.startUpdate();
				}
				else {
					this_.initGameSDK();
				}
			});
		}
	},
	initGameSDK : function() {
		this.updateView.setTips("正在初始化游戏...");
		var this_ = this;
		this.jsc.initSdk(function(code, vals) {
			if(code == 1) {	//初始化失败
				//TODO:做提示并重新初始化？
				this_.initGameSDK();
			}
			else {	//其它当成功
				this_.startUpdate();
			}
		});
	},
	initGame : function() { 
		if(this.gameConfig.isWin()) {
			try {
				new GameStart(this);
			}
			catch(e) {
				this.printError(e);
			}
		}
		else {
			new GameStart(this);
		}
	},
	enterGame:function()
	{
		var this_ = this;

		// 更新完成
		this.stat(3);

		var list = null;
		if(this.isOtherGame && this.gameConfig.isOtherGame)
		{
			list = cc.game.config.oldVersionExternList;
		}
		else
		{
			list = cc.game.config.externList;
		}
		if(!!list) {
			print("#cc.externList", list);
			cc.loader.loadJs(list, function(){
				this_.initGame();
			});
		}
		else {
			this.initGame();
		}
	},
	startUpdate:function()
	{
		print("#startUpdate");
		this.updateView.setTips("正在检测游戏资源(本过程不消耗流量)...");
		this.updateMgr.checkUpdate();

		//跳过更新
		// this.updateMgr.updateComplete();
	},
	printError:function(e)
	{
		print("------------------报错开始---------------------------");
		var arr = e.stack.split("\n");
		var content = "";
		for(var i = 0; i < arr.length; i++)
		{
			var t = arr[i].split("@");
			if(t.length >= 2)
			{
				content += t[1] + "\n";
			}
		}
		print(e.message);
		print(content);
		print("-------------------报错结束-------------------------");
	},

	clearUpdateView:function()
	{
		if(this.updateView != null && !!this.updateView.getParent())
		{
			this.updateView.getParent().removeChild(this.updateView);
		}
	},
	showUpdateView : function() {
		if(!!this.updateView) {
			this.addChild(this.updateView, 100);
		}
	},
	startDownBPackage : function(completeCallback, downList) {
		if(!this.updateMgr) return false;
		if(!!this.updateMgr && this.updateMgr.isLoading()) return false;
		var list = downList || this.updateMgr.getLeastBPackage();
		this.updateMgr.downloadPackage(list, completeCallback);
		return true;
	},
	needBPackage : function() {
		var list = this.updateMgr.getLeastBPackage();
		return !!list && list.length > 0;
	}

},"GameScene");

var GameUpdate = cc.Class.extend({
	scene : null,

	isNeedRestart : false,
	mgr : null,

	_mixPath : "res/start.txt",
	_startZip : "res/start.zip",

	_additionKey : "ADDITIONVERSION",
	// _bPackageKey : "BPACKAGEKEY",
	_plusSubffix : "bhijk",
	_updatePaths : null,
	_additionPackets : null,
	_updateCount : 0,
	_currentItem : null,
	_tryTime : 300,
	_dispose : false,
	_restartList : null,
	_completeCallback : null,

	percentPast : -1,
	_hasError : 0,
	_downUrls : null,
	_writablePath : null,
	_versionPath : null,
	_tmpFile : null,
	ctor : function(gameScene) {
		this.scene = gameScene;
		this._updatePaths = [];
		this._additionPackets = [];
		this._restartList = [];
		this._downUrls = [];
		this._tryTime = 300;

		this.init();
	},
	setNowProgress : function(percent, addStr) { 
		addStr = addStr || "";
		var count = this._updateCount,
			idx = count - this._updatePaths.length;
		if(addStr == "..") {
			var tpercent = Math.ceil( (idx - 1) / count * 100 );
			percent = tpercent + Math.ceil( percent * (100 / count) / 100 );
		}
		percent = Math.max(this.percentPast, percent);
		percent = Math.max(0, Math.min(100, percent));
		if( percent != this.percentPast) {
			this.scene.updateView.setProgress(percent);
		}
		if(!!this._currentItem) {
			var tipStr = "正在更新资源{4} {0} ({1}/{2}) {3}%".format(this._currentItem.p, idx, count, percent, addStr);
			this.showTips(tipStr);
		}
		this.percentPast = percent;
	},
	showTips : function(tipStr) {
		this.scene.updateView.setTips(tipStr);
	},
	init : function() {

		print("### (.)准备更新，(..)正在下载，(...)正在解压缩，!Error(序号)，");

		var AssetsManager = jsb.AssetsUpdateMgr,
			writePath = jsb.fileUtils.getWritablePath(),
			version = this.scene.jsc.getVerionPath(),
			tmpFile = version + ".zip",
			verPath = writePath + version,
			this_ = this;
		AssetsManager.setVersion(version);
		var mgr = AssetsManager.create(function(obj, code) {
				print("#errorCall", code);
				switch(code) {
					case 0:
						// 创建文件失败,直接提示
						print("#创建文件失败");
						this_.setNowProgress(this_.percentPast, "!");
						this_.redownload();
						break;
					case 1:
						// 网络问题  提示，并且重新下载
						print("#网络问题或文件不存在");
						this_.setNowProgress(this_.percentPast, "!.");
						this_.redownload();
						break;
					case 2:
						// 没有新版本
						print("#没有新版本");
						this_.setNowProgress(this_.percentPast, "!..");
						this_.updateComplete();
						break;
					case 3:
						// 解压缩失败,重新下载
						print("#解压缩失败,重新下载");
						this_.setNowProgress(this_.percentPast, "!...");
						this_.redownload();
						break;
				}
			},
			function(obj, progress) {
				// print("#progress", obj, progress);
				this_.setNowProgress(progress, "..");
			},
			function(obj, code) {
				//code: 3:单个开始, 4:单个结束, 5:解压开始, 6:解压结束
				print("#success", obj, code);
				switch(code) {
					case 4:
						//开始解压
						mgr.uncompress();
						break;
					case 5:
						this_.setNowProgress(this_.percentPast, "...");
						break;
					case 6:
						mgr.removeDownloadPacket();
						if(!!this_._currentItem) {
							if(this_._currentItem.t == "a") {
								this_.scene.jsc.writeKV(this_._additionKey, this_._currentItem.v);
							}
							// if(this_._currentItem.t == "b") {
							// 	this_.scene.jsc.writeKV(this_._bPackageKey, this_._currentItem.v);
							// }
							else if(this_._currentItem.t == "c") {
								this_.scene.jsc.writeKV(this_.scene.jsc.CODE_VERSION, this_._currentItem.v);
							}
							if("cdfugv".indexOf(this_._currentItem.t) > -1) {
								this_.scene.gameConfig.resVersion = parseInt(this_._currentItem.v);
							}
							if(!this_.isNeedRestart) {
								for (var i = 0; i < this_._restartList.length; i++) {
									if(this_._restartList[i] == this_._currentItem.v) {
										this_.isNeedRestart = true;
										print("#isNeedRestart!!!");
									}
								}
							}
							if(!!this_._completeCallback) {
								this_._completeCallback(this_._currentItem.p);
							}
						}
						// cc.director.restart();
						this_._hasError = 0;
						this_.updateNext();
						break;
				}
			}
		);
		this.mgr = mgr;
		this._writablePath = writePath;
		this._versionPath = verPath;
		this._tmpFile = tmpFile;

		this.resetConfig();
	},
	resetConfig : function() {
		this.percentPast = -1;
		this.mgr.setWriteablePath(this._versionPath);
		this.mgr.setTempZipFilename(this._tmpFile);
		this.mgr.setUncompressPath(this._versionPath);
		print("#删除文件:", this._versionPath + "/" + this._tmpFile, this._versionPath + "/" + this._tmpFile + ".tmp");
		this.mgr.removeFile(this._versionPath + "/" + this._tmpFile);
		this.mgr.removeFile(this._versionPath + "/" + this._tmpFile + ".tmp");
	},
	isLoading : function() {
		return this._currentItem != null;
	},
	redownload : function() {
		if(this._tryTime > 0) {
			this._tryTime--;
			this._updatePaths.unshift(this._currentItem);
			this.mgr.removeDownloadPacket();
			this.mgr.removeFile(this._versionPath + "/" + this._tmpFile + ".tmp");
			this.updateNext();
		}
	},
	updateNext : function() {
		if(!!this._updatePaths && this._updatePaths.length > 0) {
			this._currentItem = this._updatePaths.splice(0, 1)[0];
			this.setNowProgress(this.percentPast, ".");
			var url = this._downUrls[0];
			if(this._hasError == 1 && !!this._downUrls[1]) {
				url = this._downUrls[1];
			}
			this._hasError++;
			var downloadFile = url + this._currentItem.p + ".zip";
			if(this._currentItem.t == "a" || this._plusSubffix.indexOf(this._currentItem.t) > -1) {
				this.mgr.setWriteablePath(this._writablePath);
				this.mgr.setUncompressPath(this._writablePath);
			}
			else {
				this.mgr.setWriteablePath(this._versionPath);
				this.mgr.setUncompressPath(this._versionPath);
			}
			this.mgr.download(downloadFile);
		}
		else {
			if(!!this.scene.updateView) {
				this.showTips("正在为您启动游戏,请稍等...");
			}
			this._currentItem = null;
			this.updateComplete();
		}
	},
	updateComplete : function() {
		this.scene.gameConfig.downUrls = this._downUrls;

		if(!!this._completeCallback) {
			var cb = this._completeCallback;
			this._completeCallback = null;
			cb();
		}
		else {
			if(this.isNeedRestart) {
				var tips = "正在重新启动游戏",
					count = 0,		
					this_ = this;
				function callback() {
					if(count < 3) {
						tips += ".";
						this_.showTips(tips);
					}
					else {
						this_.scene.unschedule(callback);
						cc.director.restart();
					}
					count++;
				}
				this.scene.schedule(callback, 0.5);
			}
			else { 
				if(this.scene.updateView != null) {
					this.showTips("资源检测中(本过程不消耗流量)...");
				}
				this.scene.enterGame();
			} 
		}
		this.dispose();
	}, 
	checkUpdate : function() {
		var this_ = this,
			sdkId = this_.scene.gameConfig.sdkId;

		function loadVersion(filename, callback) {
			var filename = filename || "version.txt";
			var callback = callback || requestVersionCallback;
			var url = this_._downUrls[0];
			if(this_._hasError == 1 && !!this_._downUrls[1]) {
				url = this_._downUrls[1];
			}
			print("#version url", url);
			if(!!url) {
				this_.showTips("游戏启动中...");
				// this_.load(url + "version.txt", requestVersionCallback);
				this_.load(url + filename, callback);
			}
			else {
				this_.updateComplete();
			}
			this_._hasError++;
		}

		function requestVersionCallback(txt) {
			print("#requestVersionCallback", txt);
			if(!txt || txt.length == 0) {
				print("#version.txt 加载失败");
				loadVersion();
				return;
			}
			this_.showTips("正在为您启动游戏!..");
			this_.scene.gameConfig.versionContent = txt;
			var vals = txt.split("\r\n"),
				codes = [],
				passVer = this_.scene.gameConfig.resVersion,
				currentVer = 0,
				additionStr = "",
				validStr = "cdf";
			for(var i = 0; i < vals.length; i++) {
				var t = vals[i].substring(0, 1);
				if(this_.scene.gameConfig.isDownload) {
					if(t == "c") {
						if(this_.scene.gameConfig.needUpdate()) {
							currentVer = parseInt(vals[i].substring(1));
							if(currentVer > passVer) {
								codes.push({ v : currentVer, p : vals[i], t : t });
							}
						}
						validStr = "";
					}
				}
				else {
					if(t == "p") {	//审核版本
						// var vars = [];
						// var allVer = vals[i].split(",");
						// for(var j = 0; j < allVer.length; j++) {
						// 	vars.push(allVer[j].substring(1));
						// 	print("#config bigversion", vars[j]);
						// }
						// print("#bigversion:", this_.scene.gameConfig.bigVersion);
						// this_.scene.gameConfig.shenHeBigVersion = vars;
					}
					else if("cdfug".indexOf(t) > -1) { //普通更新内容
						if(this_.scene.gameConfig.needUpdate()) {
							currentVer = parseInt(vals[i].substring(1));
							if(currentVer > passVer) {
								codes.push({ v : currentVer, p : vals[i], t : t });
							}
						}
						validStr = validStr.replace(t, "");
					}
					else if(t == "v") { //普通资源更新 
						if(this_.scene.gameConfig.needUpdate()) {
							var vers = vals[i].split(",");
							for(var j = 0; j < vers.length; j++) {
								currentVer = parseInt(vers[j].substring(1));
								if(currentVer > passVer) {
									codes.push({ v : currentVer, p : vers[j], t : t });
								}
							}
						}
					}
					else if(this_._plusSubffix.indexOf(t) > -1) { //增量包 
						if(!this_.scene.gameConfig.plusList) this_.scene.gameConfig.plusList = [];
						// var vers = vals[i].split(",");
						this_.scene.gameConfig.plusList.push(vals[i]);
						print("#bpackage", vals[i]);
					}
					else if(t == "r") {
						this_._restartList = [];
						var vers = vals[i].split(",");
						for(var j = 0; j < vers.length; j++) {
							this_._restartList.push(vers[j].substring(1));
						}
					}
					else if(t == "a") { //分包,用于进游戏就会立即更新 
						additionStr = vals[i];
					}
					else if(t == "n") { // mini包dv版本号
						try {
							this_.scene.gameConfig.dvVersion = parseInt(vals[i].substring(1));
						}
						catch(e) {
							print("#获取dv版本号失败", vals[i]);
						}
					}
				}
			}
			if(validStr.length > 0) {
				print("#验证不通过", validStr);
				loadVersion();
				return;
			}

			codes.sort(function(a,b){
				return a.v - b.v;
			}); 

			var additionVersion = this_.scene.jsc.readKV(this_._additionKey);
			passVer = 0;
			if(!!additionVersion && additionVersion.length > 0) {
				passVer = parseInt(additionVersion);
			}
			var vers = additionStr.split(",");
			for(var j = vers.length - 1; j >= 0; j--) {
				currentVer = parseInt(vers[j].substring(1));
				if(currentVer > passVer) {
					if(this_.scene.gameConfig.needAdditionUpdate()) {
						codes.unshift({ v : currentVer, p : vers[j], t : "a", idx : j, count : vers.length });
					}
				}
			}

			//过滤审核版本
			var vlist = this_.scene.gameConfig.shenHeBigVersion,
				bigV = this_.scene.gameConfig.bigVersion;
			if(!!vlist) {
				for(var i = 0; i < vlist.length; i++) {
					if(vlist[i] == bigV) {
						codes = [];
						this_.scene.isOtherGame = true;
					}
				}
			}

			this_._updatePaths = codes;
			this_._updateCount = codes.length;

			// 通过版本检测
			this_.scene.stat(2);

			if(this_._updateCount > 0) {
				this_.showTips("正在为您启动游戏...");
				print("#start update", this_._updateCount);
				this_._hasError = 0;
				this_.updateNext();
			}
			else {
				print("#没有版本更新");
				this_.updateComplete();
			}
		}

		function requestShenheCallback(txt) {
			print("#requestShenheCallback", txt);
			if(!!txt && txt.length > 0) {

				var vals = txt.split("\r\n");
				for(var i = 0; i < vals.length; i++) {
					var t = vals[i].substring(0, 1);
					if(t == "p") {	//审核版本
						var vars = [];
						var allVer = vals[i].split(",");
						for(var j = 0; j < allVer.length; j++) {
							vars.push(allVer[j].substring(1));
							print("#config bigversion", vars[j]);
						}
						print("#bigversion:", this_.scene.gameConfig.bigVersion);
						this_.scene.gameConfig.shenHeBigVersion = vars;
					}
				}
				loadVersion();
			}
			else { 
				print("#shenhe.txt 加载失败"); 
				loadVersion("shenhe.txt", requestShenheCallback);
			}
		}

		function formatDownloadUrl(url) {
			if(!!url && url.length > 0) {
				if(url.substr(-1, 1) != "/") {
					url += "/";
				}
				if(this_.scene.gameConfig.isIOS()) {
					url += "ios/";
				}
				else {
					url += "android/";
				}
			}
			return url;
		}

		function urlHandler(txt) {
			print("#urlHandler:", txt);
			if(!!txt && txt.length > 0) {
				var vals = txt.split("\r\n");
				if(!!vals && vals.length > 0) {
					var hasUrl = false, dict = {};
					for(var i = 0; i < vals.length; i++) {
						var item = vals[i].split("###");
						print("#sdkId:{0}, url:{1}".format(item[0], item[1]));
						if(!!item && item.length == 2) {
							dict[item[0]] = item[1];
							hasUrl = true;
						}
					}
					if(hasUrl) {
						// 更新包下载地址
						var key = sdkId.toString(),
							url = dict[key];
						if(!url) {
							key = "0";
							url = dict[key];
						}
						print("#sdkId", sdkId, key, dict[key], dict["0"], url);
						if(this_.scene.gameConfig.isNoSdkOrTestSdk()) {
							key = "-1";
							url = dict[key];
						}
						url = formatDownloadUrl(url);
						print("#first Url:{0}".format(url));
						this_._downUrls.push(url);
						var newUrl = dict[(parseInt(key) + 20000).toString()];
						if(!!newUrl) {
							newUrl = formatDownloadUrl(newUrl);
							this_._downUrls.push(newUrl);
							print("#second Url:{0}".format(newUrl));
						} 
						loadVersion("shenhe.txt", requestShenheCallback);

						// 资源包下载地址
						if(this_.scene.gameConfig.isDownload) {
							var downloadUrl = this_.scene.gameConfig.downloadUrl;
							if(this_.scene.gameConfig.isNoSdkOrTestSdk()) {
								this_.scene.gameConfig.downloadUrl = dict["test"] || downloadUrl;
							}
							else {
								this_.scene.gameConfig.downloadUrl = dict["pkgs"] || downloadUrl;
							}
							print("#资源包下载地址", this_.scene.gameConfig.downloadUrl);
						}
					}
					else {
						this_.updateComplete();
					}
				}
			}
		}

		if(this.scene.gameConfig.needUpdate()) {
			var url = this.scene.gameConfig.getVerUrl("url.txt");
			print("#url.txt path:", url);
			this.load(url, urlHandler, true);
		}
		else {
			this.updateComplete();
		}
	},
	firstOpen : function(completeCallback) {
		this._completeCallback = completeCallback;
		if( this.scene.gameConfig.isIOS()) {	//未解压缩过
			var mixPath = jsb.fileUtils.fullPathForFilename(this._mixPath);
			print("#mixPath", mixPath);
			if(!mixPath || mixPath.length == 0) { 
				var zipPath = jsb.fileUtils.fullPathForFilename(this._startZip);
				print("#zipPath", zipPath);
				if(!!zipPath && zipPath.length > 0) {
					this.showTips("第一次启动游戏，现在检测...");
					this.setNowProgress(90);
					// 设置压缩包路径
					// 设置解压缩路径
					// 开工
					var lastSepIdx = zipPath.lastIndexOf("/"),
						fileFolder = zipPath.substr(0, lastSepIdx),
						fileName = zipPath.substr(lastSepIdx + 1, zipPath.length);
					print("#folder:{0}, name:{1}".format(fileFolder, fileName));

					this.mgr.setWriteablePath(fileFolder);
					this.mgr.setTempZipFilename(fileName);
					this.mgr.setUncompressPath(this._writablePath);
					this.mgr.uncompress();
					return;
				}
			} 
		} 
		this.updateComplete();
	},
	downloadPackage : function(list, completeCallback) {
		this._completeCallback = completeCallback;
		if(!!list && list.length > 0) { 
			var codes = [],
				currentVer = 0;
			for(var j = list.length - 1; j >= 0; j--) {
				if(!!list[j]) {
					currentVer = parseInt(list[j].substring(1)); 
					codes.unshift({ v : currentVer, p : list[j], t : list[j].substring(0, 1), idx : j, count : list.length });
				}
			}

			this._updatePaths = codes;
			this._updateCount = codes.length;

			if(this._updateCount > 0) {
				this.showTips("正在为您下载更新包...");
				print("#start update", this._updateCount);
				this._hasError = 0;
				this._dispose = false;
				this.percentPast = 0;
				this.updateNext();
				return;
			} 
		}
		if(!!this._completeCallback) {
			this._completeCallback();
		}
	},
	load : function(url, callback, utilSuccess) {
		var randomNum = Math.random(),
			loadUrl = url,
			this_ = this;
		if(loadUrl.indexOf("?") > -1) loadUrl += "&" + randomNum;
		else loadUrl += "?" + randomNum;
		print("#update loadUrl", loadUrl);
		cc.loader.loadTxtRemote(loadUrl, function(errInfo, txt) {
			if(!!callback) {
				if(!!errInfo || !txt || txt.length == 0) {
					print("#load failed:{0}, reason:{1}".format(url, errInfo));
					callback(null);
					if(!!utilSuccess && !this._dispose) {
						this_.load(url, callback, utilSuccess);
					}
				}
				else {
					callback(txt);
				}
			}
		});
	},
	dispose : function() {
		this._dispose = true;
	}
},"GameUpdate");